Date: 2022-09-01
Tag: 2.10.2

## Overview

2.10.2 is the third [stable][release_policy] version of the 2.10 release
series. It introduces 1 improvements and resolves 8 bugs since
2.10.1.

The "stable" label means that we have all planned features implemented and we
see no high-impact issues. However, if you encounter an issue, feel free to
[report it][issues] on GitHub.

[release_policy]: https://www.tarantool.io/en/doc/latest/dev_guide/release_management/#release-policy
[issues]: https://github.com/tarantool/tarantool/issues

## Compatibility

Tarantool 2.x is backward compatible with Tarantool 1.10.x in the binary data
layout, client-server protocol, and replication protocol.

Please [upgrade][upgrade] using the `box.schema.upgrade()` procedure to unlock
all the new features of the 2.x series.

[upgrade]: https://www.tarantool.io/en/doc/latest/book/admin/upgrades/

## Functionality added or changed

### Core

* Certain internal fibers, such as the connection's worker fiber, vinyl fibers,
  and some other fibers, cannot be cancelled from the Lua public API
  anymore (gh-7473).

## Bugs fixed

### Core

* Fixed a possible crash on concurrent `fiber_object:join()` (gh-7489).
* Fixed a potential nil dereference and a crash in case of an active
  log rotation during the program exit stage (gh-4450).
* Fixed crashes and undefined behaviour of triggers clearing other triggers
  (gh-4264).
* Fixed a crash of secondary indexes without hints (gh-7605)

### Replication

* Fixed `box.info.replication[id].downstream.lag` growing indefinitely on a
  server when it's not writing any new transactions (gh-7581).

### Box

* Fixed multiline commands being saved to `~/.tarantool_history` as
  separate lines (gh-7320).
* Fixed inheritance of field options in indexes when index parts are
  specified the old Tarantool 1.6 style: `{<field>, <type>, ...}` (gh-7614).
* Fixed unauthorized inserts into the `_truncate` space (ghs-5).
